/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// TimeGeneralDateTimeDescription Description of date and time structured with separate values for the various elements of a calendar-clock system
type TimeGeneralDateTimeDescription interface {
	TimeTemporalPosition
	timeUnitTypeSingleTimeTemporalUnit
	timeDaySingleTime
	timeDayOfWeekSingleTimeDayOfWeek
	timeDayOfYearSingleint
	timeHourSingleint
	timeMinuteSingleint
	timeMonthSingleTime
	timeMonthOfYearSingleTimeMonthOfYear
	timeSecondSinglefloat64
	timeZoneSingleTimeZone
	timeWeekSingleint
	timeYearSingleTime
	IsTimeGeneralDateTimeDescription() bool // indicates base class
}

// sTimeGeneralDateTimeDescription Description of date and time structured with separate values for the various elements of a calendar-clock system
type sTimeGeneralDateTimeDescription struct {
	sTimeTemporalPosition
	propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit
	propTimeDayBaseGoTimeTypeGoTimeSingleGoTime
	propTimeDayOfWeekBaseTimeDayOfWeekTypeTimeDayOfWeekSingleTimeDayOfWeek
	propTimeDayOfYearBaseintTypeintSingleint
	propTimeHourBaseintTypeintSingleint
	propTimeMinuteBaseintTypeintSingleint
	propTimeMonthBaseGoTimeTypeGoTimeSingleGoTime
	propTimeMonthOfYearBaseTimeMonthOfYearTypeTimeMonthOfYearSingleTimeMonthOfYear
	propTimeSecondBasefloat64Typefloat64Singlefloat64
	propTimeZoneBaseTimeZoneTypeTimeZoneSingleTimeZone
	propTimeWeekBaseintTypeintSingleint
	propTimeYearBaseGoTimeTypeGoTimeSingleGoTime
}

// NewTimeGeneralDateTimeDescription creates a new TimeGeneralDateTimeDescription
func (mod *Model) NewTimeGeneralDateTimeDescription(iri string) (ret TimeGeneralDateTimeDescription, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sTimeGeneralDateTimeDescription{}
	pc := propCommon{iri: iri, typ: "TimeGeneralDateTimeDescription", model: mod}
	res.propCommon = pc
	mod.addTimeGeneralDateTimeDescription(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sTimeGeneralDateTimeDescription) makeMaps() {
	res.sTimeTemporalPosition.makeMaps()
	return
}

// addTimeGeneralDateTimeDescription adds TimeGeneralDateTimeDescription to model
func (mod *Model) addTimeGeneralDateTimeDescription(res TimeGeneralDateTimeDescription) {
	mod.mTimeGeneralDateTimeDescription[res.IRI()] = res
	mod.addTimeTemporalPosition(res)
	return
}

// TimeGeneralDateTimeDescription returns all resources with given prefix
func (mod *Model) TimeGeneralDateTimeDescription(prefix string) (res []TimeGeneralDateTimeDescription) {
	for i := range mod.mTimeGeneralDateTimeDescription {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mTimeGeneralDateTimeDescription[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sTimeGeneralDateTimeDescription) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "http://www.w3.org/2006/time#unitType":
		res.propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit.removeObject(obj)
	case "http://www.w3.org/2006/time#dayOfWeek":
		res.propTimeDayOfWeekBaseTimeDayOfWeekTypeTimeDayOfWeekSingleTimeDayOfWeek.removeObject(obj)
	case "http://www.w3.org/2006/time#monthOfYear":
		res.propTimeMonthOfYearBaseTimeMonthOfYearTypeTimeMonthOfYearSingleTimeMonthOfYear.removeObject(obj)
	case "http://www.w3.org/2006/time#timeZone":
		res.propTimeZoneBaseTimeZoneTypeTimeZoneSingleTimeZone.removeObject(obj)
	default:
		res.sTimeTemporalPosition.RemoveObject(obj, prop)
	}
	return
}

// isTimeGeneralDateTimeDescription indicates base class
func (res *sTimeGeneralDateTimeDescription) IsTimeGeneralDateTimeDescription() bool {
	return true
}

// InitFromNode initializes the resource from a graph node
func (res *sTimeGeneralDateTimeDescription) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sTimeGeneralDateTimeDescription) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "http://www.w3.org/2006/time#unitType":
		res.propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#day":
		res.propTimeDayBaseGoTimeTypeGoTimeSingleGoTime.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#dayOfWeek":
		res.propTimeDayOfWeekBaseTimeDayOfWeekTypeTimeDayOfWeekSingleTimeDayOfWeek.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#dayOfYear":
		res.propTimeDayOfYearBaseintTypeintSingleint.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#hour":
		res.propTimeHourBaseintTypeintSingleint.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#minute":
		res.propTimeMinuteBaseintTypeintSingleint.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#month":
		res.propTimeMonthBaseGoTimeTypeGoTimeSingleGoTime.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#monthOfYear":
		res.propTimeMonthOfYearBaseTimeMonthOfYearTypeTimeMonthOfYearSingleTimeMonthOfYear.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#second":
		res.propTimeSecondBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#timeZone":
		res.propTimeZoneBaseTimeZoneTypeTimeZoneSingleTimeZone.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#week":
		res.propTimeWeekBaseintTypeintSingleint.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#year":
		res.propTimeYearBaseGoTimeTypeGoTimeSingleGoTime.init(pred.Object.Term.String())
	default:
		res.sTimeTemporalPosition.propsInit(pred)
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sTimeGeneralDateTimeDescription) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "http://www.w3.org/2006/time#GeneralDateTimeDescription", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sTimeGeneralDateTimeDescription) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.sTimeTemporalPosition.propsToGraph(node, g)
	res.propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit.toGraph(node, g)
	res.propTimeDayBaseGoTimeTypeGoTimeSingleGoTime.toGraph(node, g)
	res.propTimeDayOfWeekBaseTimeDayOfWeekTypeTimeDayOfWeekSingleTimeDayOfWeek.toGraph(node, g)
	res.propTimeDayOfYearBaseintTypeintSingleint.toGraph(node, g)
	res.propTimeHourBaseintTypeintSingleint.toGraph(node, g)
	res.propTimeMinuteBaseintTypeintSingleint.toGraph(node, g)
	res.propTimeMonthBaseGoTimeTypeGoTimeSingleGoTime.toGraph(node, g)
	res.propTimeMonthOfYearBaseTimeMonthOfYearTypeTimeMonthOfYearSingleTimeMonthOfYear.toGraph(node, g)
	res.propTimeSecondBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	res.propTimeZoneBaseTimeZoneTypeTimeZoneSingleTimeZone.toGraph(node, g)
	res.propTimeWeekBaseintTypeintSingleint.toGraph(node, g)
	res.propTimeYearBaseGoTimeTypeGoTimeSingleGoTime.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sTimeGeneralDateTimeDescription) String() (ret string) {
	ret = res.iri + " " + "TimeGeneralDateTimeDescription\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sTimeGeneralDateTimeDescription) propsString() (ret string) {
	ret = ""
	ret += res.sTimeTemporalPosition.propsString()
	ret += res.propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit.String()
	ret += res.propTimeDayBaseGoTimeTypeGoTimeSingleGoTime.String()
	ret += res.propTimeDayOfWeekBaseTimeDayOfWeekTypeTimeDayOfWeekSingleTimeDayOfWeek.String()
	ret += res.propTimeDayOfYearBaseintTypeintSingleint.String()
	ret += res.propTimeHourBaseintTypeintSingleint.String()
	ret += res.propTimeMinuteBaseintTypeintSingleint.String()
	ret += res.propTimeMonthBaseGoTimeTypeGoTimeSingleGoTime.String()
	ret += res.propTimeMonthOfYearBaseTimeMonthOfYearTypeTimeMonthOfYearSingleTimeMonthOfYear.String()
	ret += res.propTimeSecondBasefloat64Typefloat64Singlefloat64.String()
	ret += res.propTimeZoneBaseTimeZoneTypeTimeZoneSingleTimeZone.String()
	ret += res.propTimeWeekBaseintTypeintSingleint.String()
	ret += res.propTimeYearBaseGoTimeTypeGoTimeSingleGoTime.String()
	return
}


